
/* Generated by Interface Builder */

#import "IncidentView.h"
#import <dpsclient/wraps.h>
#import <appkit/Application.h>
#import <appkit/NXCursor.h>


#import "arrow.h"	/* pswarp include file */
#import <math.h>

@implementation IncidentView

- drawSelf:(const NXRect *)rects :(int)rectCount
{	
	float incAngle,xend,yend;

		/* initialize plot area */
	PSgsave();
        PSsetgray(1.0);
        PSrectfill(bounds.origin.x,bounds.origin.y,bounds.size.width,bounds.size.height);
	PSsetgray(0.0);
        PSgrestore();
	
		/* set coordinate frame */
	PStranslate(bounds.size.width/2.0,bounds.size.height/2.0);
	
		/* draw a simple representation of the crustal layers */
	PSsetgray(0.333);
	PSrectfill((-1.0*bounds.size.width/2.0),(-1.0*bounds.size.height/2.0),bounds.size.width,
		(bounds.size.height*3.0/4.0));
	PSsetgray(0.667);
	PSrectfill((-1.0*bounds.size.width/2.0),0.0,bounds.size.width,(bounds.size.height/4.0));
	PSsetgray(0.0);
	PSrectstroke((-1.0*bounds.size.width/2.0),0.0,(bounds.size.width-1),(bounds.size.height/4.0));
	
		/* now draw a few buildings on top */
	PSrectfill((-1.0*bounds.size.width/3.0),(bounds.size.height/4.0),10.0,20.0);
	PSrectfill((-1.0*bounds.size.width/3.0)+10,(bounds.size.height/4.0),10.0,15.0);
	
		/* get incident angle from delegate */
	if(delegate && [delegate respondsTo:@selector(getIncidentAngle)])
		incAngle=[delegate getIncidentAngle];
	if(incAngle < 0.0)incAngle *= -1.0;
		
		/* calculate end point of arrow */
	alength=bounds.size.height*0.9/2.0;
	yend= -1.0*alength*cos(incAngle/57.29577951);
	xend=alength*sin(incAngle/57.29577951);
	
		/* draw arrow showing the incoming plane wave */
	arrow(xend,yend,0.0,0.0,8.0,20.0,25.0,20.0,0.0);
	PSsetgray(0.0);
	PSfill();
	arrow(xend,yend,0.0,0.0,8.0,20.0,25.0,20.0,0.0);
	PSsetgray(0.667);
	PSstroke();

	
	return self;
}

- mouseDown:(NXEvent *)theEvent
{
        int oldmask,mouseup=NO;
      	float newangle,xpt,ypt;
        NXEvent *event;
	NXPoint	point;
	
        	/* save old event mask */
        oldmask = [window addToEventMask:NX_LMOUSEDRAGGEDMASK];

 		/* now do instance drawing */
	[self lockFocus];
        PSsetinstance(YES);
	
		/* calculate angle from origin to point */
	point=theEvent->location;
        [self convertPoint:&point fromView:nil];
	xpt=point.x-bounds.size.width/2.0;
	ypt=point.y-bounds.size.height/2.0;
	if(ypt < 0.0)ypt *= -1.0;
	newangle=atan2(xpt,ypt)*57.29566951;
	
		/* change coordinate frame to that used in draw */
	PStranslate(bounds.size.width/2.0,bounds.size.height/2.0);
	
		/* draw the instance of the model */
	[self drawInstance:newangle];
		
        	/* loop until mouse up */
        while(!mouseup) 
	{
               		 /* get mouse event and location */
                event = [NXApp getNextEvent:
                        (NX_LMOUSEUPMASK | NX_LMOUSEDRAGGEDMASK)];
               	point = event->location;
                [self convertPoint:&point fromView:nil];
                
                	/* if mouse up, break */
               	if (event->type==NX_LMOUSEUP) 
		{
                       	mouseup=YES;
                
                }
		else /* else if mouse dragged, update velocity model */
               {
			 if (event->type==NX_LMOUSEDRAGGED) 
			 {
			 	xpt=point.x-bounds.size.width/2.0;
				ypt=point.y-bounds.size.height/2.0;
				if(ypt < 0.0)ypt *= -1.0;
				newangle=atan2(xpt,ypt)*57.29566951;
	
					/* redraw and instance of the model */
				PSnewinstance();
				[self drawInstance:newangle];
				if(newangle < 0.0)newangle *= -1.0;
				
					/* update instance variable in the controller */
				if(delegate && [delegate respondsTo:@selector(putIncidentAngle:)])
					[delegate putIncidentAngle:newangle];
				
			}
                }
        }
        
       		 /* finished drawing */
        PSnewinstance();
        PSsetinstance(NO);
        [self unlockFocus];
        
        	/* restore event mask */
        [window setEventMask:oldmask];
	
		/* update instance variables in delegate and the form */
	[self display];
	
	return self;
}

- drawInstance:(float)newangle
{
	float xend,yend;
	
		/* draw instance of new arrow */
	yend= -1.0*alength*cos(newangle/57.29577951);
	xend=alength*sin(newangle/57.29577951);

		/* draw arrow showing the incoming plane wave */
	arrow(xend,yend,0.0,0.0,8.0,20.0,25.0,20.0,0.0);
	PSsetgray(0.333);
	PSfill();
	arrow(xend,yend,0.0,0.0,8.0,20.0,25.0,20.0,0.0);
	PSsetgray(0.667);
	PSstroke();

	return self;
}

- resetCursorRects
{
    NXRect visible;
    if ([self getVisibleRect:&visible]) {
        [self addCursorRect:&visible cursor:NXArrow];
    }
    return self;
}

@end
