
/* Generated by Interface Builder */

#import "ModelControl.h"
#import "DataView.h"
#import <appkit/Form.h>
#import <string.h>
#import <stdlib.h>

@implementation ModelControl

-init
{
	float *temp;
	
	/* cluge because haskell code wants the arrays to start at 1 */
	temp=(float *)calloc(MAXLAYERS+1,sizeof(float));
	P=temp+1;
	temp=(float *)calloc(MAXLAYERS+1,sizeof(float));
	S=temp+1;
	temp=(float *)calloc(MAXLAYERS+1,sizeof(float));
	RHO=temp+1;
	temp=(float *)calloc(MAXLAYERS+1,sizeof(float));
	Q=temp+1;
	temp=(float *)calloc(MAXLAYERS+1,sizeof(float));
	Z=temp+1;
	
	/* set default values for model */
	
	numLayers=3;
	
	*(Z-1)=0.0;
	Z[0]=1.0;
	Z[1]=2.0;
	Z[2]=4.0;
	P[0]=1.0;
	P[1]=2.0;
	P[2]=5.0;
	S[0]=0.75;
	S[1]=1.5;
	S[2]=4.0;
	RHO[0]=1.0;
	RHO[1]=2.0;
	RHO[2]=2.5;
	Q[0]=200.0;
	Q[1]=400.0;
	Q[2]=1000.0;

	return self;
}

- prepareArea
{
	int i;
	float tmax;
	
		/* first set limits */
	[pPlot setXMax:Z[numLayers-1]];
	[sPlot setXMax:Z[numLayers-1]];
	[rhoPlot setXMax:Z[numLayers-1]];
	[qPlot setXMax:Z[numLayers-1]];
	
	tmax=0.0;
	for(i=0;i<numLayers;i++)
		if(P[i]> tmax)tmax=P[i];	
	[pPlot setYMax:tmax];
	tmax=0.0;
	for(i=0;i<numLayers;i++)
		if(S[i]> tmax)tmax=S[i];	
	[sPlot setYMax:tmax];
	
	tmax=0.0;
	for(i=0;i<numLayers;i++)
		if(RHO[i]> tmax)tmax=RHO[i];	
	[rhoPlot setYMax:tmax];

	tmax=0.0;
	for(i=0;i<numLayers;i++)
		if(Q[i]> tmax)tmax=Q[i];	
	[qPlot setYMax:tmax];

		/* now plot views */
	[pPlot display];
	[sPlot display];
	[rhoPlot display];
	[qPlot display];
	
		/* initialze forms */
	[layerForm setIntValue:numLayers at:0];
	[depthForm setFloatValue:Z[numLayers-1] at:0];

	return self;
}

- sendModel:(float **)p:(float **)s:(float **)q:(float **)rho:(float **)z:(int *)n
{
	*p=&P[0];
	*s=&S[0];
	*rho=&RHO[0];
	*q=&Q[0];
	*z=&Z[0];
	*n=numLayers;
	
	return self;
}

	/* action methods */
- changeNumberOfLayers:sender
{
	int newnum,i;
	float fact;
	
	newnum=[layerForm intValueAt:0];
	if(newnum > MAXLAYERS)newnum=MAXLAYERS;
	
		/* values in the arrays and plot */
	if(newnum > numLayers)
	{
		for(i=numLayers;i<newnum;i++)
		{
			fact=i-(numLayers-1);
			Z[i]=Z[numLayers-1]+(fact);
			P[i]=P[numLayers-1]+(fact/2.0);
			S[i]=S[numLayers-1]+(fact/2.0);
			RHO[i]=RHO[numLayers-1]+(fact/4.0);
			Q[i]=Q[numLayers-1]+(fact*100.0);
		}
	}
	numLayers=newnum;
	[self prepareArea];
	
	return self;
}

- changeMaxDepth:sender
{
	int i,max;
	float depth,temp;
	
	depth=[depthForm floatValueAt:0];
	if(depth > Z[numLayers-1])
	{
		Z[numLayers-1]=depth;	
		[self prepareArea];
	}
	else
	{
		max=0;
		for(i=0;i<numLayers;i++)
			if(Z[i] < depth) max=i;
		max++;
		Z[max]=depth;
		if(max == 1)
		{
			if(Z[1] < Z[0])
			{
				temp=Z[0];
				Z[0]=Z[1];
				Z[1]=temp;
			}
		}
		numLayers=max+1;
		[self prepareArea];
	}
	
	return self;
}

	/* delegated methods from DataView */
	
- dataChanged:sender
{
	[self prepareArea];
	
	return self;
}

- sendDataToPlot:sender:(float **)x:(float **)y:(int *)num:(char *)xtitle:(char *)ytitle
{	
	*num=numLayers;
	*x=&Z[0];
	strcpy(xtitle,"Depth (km)");
	
	if(sender == pPlot)
	{
		*y=&P[0];
		strcpy(ytitle,"P Vel. (km/s)");
	}
	if(sender == sPlot)
	{
		*y=&S[0];
		strcpy(ytitle,"S Vel. (km/s)");
	}
	if(sender == qPlot)
	{
		*y=&Q[0];
		strcpy(ytitle,"Q");
	}
	if(sender == rhoPlot)
	{
		*y=&RHO[0];
		strcpy(ytitle,"Density (gm/cm3)");
	}
	return self;
}
@end
