
/* Generated by Interface Builder */

#import "SpecView.h"
#import "SpecControl.h"

#import <ipsplot.h>
#import <dpsclient/wraps.h>
#import <appkit/Control.h>
#import <appkit/TextField.h>
#import <appkit/Application.h>
#import <appkit/NXCursor.h>

#import <stdlib.h>
#import <math.h>

@implementation SpecView

- initFrame:(const NXRect *)frameRect
{
	[super initFrame:(const NXRect *)frameRect];
	data=NULL;
	y=NULL;
	xmin=ymin=0.0;
	xmax=ymax=1.0e+25;
	Enlarged=NO;
	pstart=pend=0;
	length=0;

	return self;
}

- prepareText
{

	/* initialize the two textfields */
	[AmpForm setStringValue:" "];
	[FreqForm setStringValue:" "];

	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
	int bbox[4],i;
	float nyquist,nf,freq_inc,scale;
	void cfftr();
	
	/* load the data from the delegate */
	
	if(delegate && [delegate respondsTo:@selector(sendDataToPlot::::)])
		[delegate sendDataToPlot:self:&y:&length:&dt];
	
	/* initialize plot area */
	
	PSgsave();
        PSsetgray(1.0);
        PSrectfill(bounds.origin.x,bounds.origin.y,bounds.size.width,bounds.size.height);
	PSsetgray(0.0);
        PSgrestore();
	
	[self prepareText];

	/* we're able to plot spectra so, calculate and plot */
	if(y != NULL)
	{
	
		/* allocate temporary work array */
		if(data != NULL)free((void *)data);
		data=(float *)calloc(length+2,sizeof(float));
		
		/* copy data into temporary work array */
		for(i=0;i<length;i++)data[i]=y[i];
		
		/* compute FFT of timeseries */
		cfftr(data,length);
				
		/* remove the taper used to construct the time series */
		for(i=0;i<=length;i+=2)
		{
			scale=(float)(i/2.0)/((length+1)/2.0);
			scale=cos( (scale*1.57079633) );
			scale= 1.0/scale;
			
			data[i] *= scale;
			data[i+1] *= scale;
		}
		
		/* compute some constants */
		nyquist=1.0/(2.0*dt);
       		nf=(int)(length/2.0+1.0);
        	freq_inc=nyquist/(float)(nf-1);

		/* compute amplitude */
                for(i=0;i<=length;i+=2)
                       data[i/2]=sqrt((double)(data[i]*data[i]+data[i+1]*data[i+1]));

	
			/* determine xmax and ymax */
		ymax=0.0;
		for(i=0;i<length/2+1;i++)
			if(ymax < fabs(data[i]))ymax=fabs(data[i]);
			
		xmax=(nf-1)*freq_inc;

			/* set width and height of plot area */
		Vwbox=bounds.size.width*0.85;
		Vhbox=bounds.size.height*0.85;
		Vxbox=bounds.size.width*0.1;
		Vybox=bounds.size.height*0.05;
		
		/* set up scale for instance drawing */
		
		xscale=Vwbox/(xmax);
		yscale=Vhbox/(1.05*ymax);
	
		/* set up to plot data */

		PSinitclip();
		PSgsave();			
		PStranslate(Vxbox,Vybox);
		
		/* plot data */	
		PSsetgray(0.0);
		ipsWiggle(nf,data,0.0,(1.05*ymax),0.0,0.0,Vhbox,0.0,Vwbox,0);
		
		PSgrestore();

			/* set bounding box */
		psAxesBBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),"Times-Roman",12.0,
			"Times-Roman",12.0,NORMAL,bbox);
		boundingbox(bbox[0],bbox[1],bbox[2],bbox[3]);
	
		/* draw axes and title */
		PSsetgray(0.0);
		ipsAxesBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),0.0,xmax,0.0,0.0,0,0,1,NONE,"",
			0.0,(1.05*ymax),0.0,0.0,0.0,0,1,NONE,"","Times-Roman",12," ",
			"Times-Roman",12,NORMAL);
	}

	return self;
}

- mouseDown:(NXEvent *)theEvent
{
	NXPoint point;
	float xval,yval,nyquist,nf,freq_inc;
	float amp,freq;
	int i;
	
	/* convert point to our coordinates */
	point=theEvent->location;
	[self convertPoint:&point fromView:nil];
	xval=(point.x-Vxbox)/xscale;
	yval=(point.y-Vybox)/yscale;

	/* find xvalue in array closest to xval */
	nyquist=1.0/(2.0*dt);
       	nf=(int)(length/2.0+1.0);
        freq_inc=nyquist/(float)(nf-1);

	i=0;
	while(xval > (float)(freq_inc*i)) i++;
	
	freq=(float)(freq_inc*i);
	amp=data[i];
	
	/* update appropriate textforms */
	[AmpForm setFloatValue:amp];
	[FreqForm setFloatValue:freq];
	
	return self;
}

- resetCursorRects
{
    NXRect visible;
    if ([self getVisibleRect:&visible]) {
        [self addCursorRect:&visible cursor:NXArrow];
    }
    return self;
}

@end

		/* Fourier Transform routines */
void cfftr(float *x, int n)
{
        int nn, is, nm, j, i;
        int k1j, k1i, k2j, k2i;
        float s, fn, ex, wr, wi, wwr, wrr, wwi, a1, a2, b1, b2;
        void scfour();
	
        nn = n/2;
        is = 1;
        scfour( x, nn, is );
        nm = nn/2;
        s = x[0];
        x[0] += x[1];
        x[n] = s - x[1];
        x[1] = 0.0 ;
        x[n+1] = 0.0;
        x[nn+1] = (-x[nn+1]);
        fn = (float) n;
        ex = 6.2831853 / fn;
        j = nn;
        wr = 1.0;
        wi = 0.0;
        wwr = (float) cos( (double) ex );
        wwi = (float) (-sin( (double) ex ));
        for (i=2; i<=nm; i++) {
                wrr = wr*wwr-wi*wwi;
                wi = wr*wwi+wi*wwr;
                wr = wrr;
                k1j = 2*j-1;
                k1i = 2*i-1;
                k2j = 2*j;
                k2i = 2*i;
                a1 = 0.5*(x[k1i-1]+x[k1j-1]);
                a2 = 0.5*(x[k2i-1]-x[k2j-1]);
                b1 = 0.5*(-x[k1i-1]+x[k1j-1]);
                b2 = 0.5*(-x[k2i-1]-x[k2j-1]);
                s = b1;
                b1 = b1*wr+b2*wi;
                b2 = b2*wr-s*wi;
                x[k1i-1] = a1-b2;
                x[k2i-1] = (-a2-b1);
                x[k1j-1] = a1+b2;
                x[k2j-1] =  a2-b1;
                j -= 1;
        }
        return;
}
void scfour( data, n, isign )
int n, isign;
float data[];
{
	int ip0, ip1, ip2, ip3, i3rev;
	int i1, i2a, i2b, i3;
	float sinth, wstpr, wstpi, wr, wi, tempr, tempi, theta;
	ip0=2;
	ip3=ip0*n;
	i3rev=1;
	for( i3=1; i3<=ip3; i3+=ip0 ) {
		if( i3 < i3rev ) {
			tempr = data[i3-1];
			tempi = data[i3];
			data[i3-1] = data[i3rev-1];
			data[i3] = data[i3rev];
			data[i3rev-1] = tempr;
			data[i3rev] = tempi;
			}
		ip1 = ip3 / 2;
		do {
			if( i3rev <= ip1 )
				break;
			i3rev -= ip1;
			ip1 /= 2;
			}
			while ( ip1 >= ip0 );
		i3rev += ip1;
		}
		ip1 = ip0;
		while ( ip1 < ip3 ) {
			ip2 = ip1 * 2;
			theta = 6.283185/( (double) (isign*ip2/ip0) );
			sinth = (double) sin( (double) (theta/2.) );
			wstpr = -2.*sinth*sinth;
			wstpi = (double) sin( (double) theta );
			wr = 1.;
			wi = 0.;
			for ( i1=1; i1<=ip1; i1+=ip0 ) {
			for ( i3=i1; i3<ip3; i3+=ip2 ) {
				i2a=i3;
				i2b=i2a+ip1;
				tempr = wr*data[i2b-1] - wi*data[i2b];
				tempi = wr*data[i2b] + wi*data[i2b-1];
				data[i2b-1] = data[i2a-1] - tempr;
				data[i2b] = data[i2a] - tempi;
				data[i2a-1] += tempr;
				data[i2a] += tempi;
				}
				tempr = wr;
				wr = wr*wstpr - wi*wstpi + wr;
				wi = wi*wstpr + tempr*wstpi + wi;
				}
			ip1=ip2;
			}
		return;
		}
